#!/bin/bash
#

vdate="16.12.2017"
vversion="01.01"

_url=""
_port=""
_file_res=""
_file_stat=""
_file_res_def="/home/httpd/ramdisk/spp.dat"
_file_stat_def="/home/httpd/ramdisk/spp.stat"
_tmp_dir="/tmp/spp"
((_memmin=750))
_sppfp1URL=""
_sppfp1port=""


#TMP=`mktemp -d`
#BACK=$TMP/pipe.back
#SENT=$TMP/pipe.sent
#RCVD=$TMP/pipe.rcvd
#trap 'rm -rf "$TMP"' EXIT
#mkfifo -m 0600 "$BACK" "$SENT" "$RCVD"
#sed 's/^/ => /' <"$SENT" &
#sed 's/^/<=  /' <"$RCVD" &


#для MOXA
#"cannot connect"

#для Debian
#"No route to host"

function _help()
{
	echo "./spp.sh -ip <ip addr> -p <ip port>                 - сканирование портов и адресов"
	echo "./spp.sh -ip <ip addr> -p <ip port> -f <file_res>   - сканирование с записью в файл"
	echo "                                                      если файл <file_res> не указан, то сохранение"
	echo "                                                      в файл \"/home/httpd/ramdisk/spp.dat\""
	echo "./spp.sh -ip <ip addr> -p <ip port> -fp <file_res>  - сканирование несколькими потоками с записью в файл"
	echo "                                                      если файл <file_res> не указан, то сохранение"
	echo "                                                      в файл \"/home/httpd/ramdisk/spp.dat\""
	echo "./spp.sh -ip <ip addr> -p <ip port> -fpd <file_res> - сканирование несколькими потоками с записью в файл"
	echo "                                                      в режиме демона"
	echo "                                                      если файл <file_res> не указан, то сохранение"
	echo "                                                      в файл \"/home/httpd/ramdisk/spp.dat\""
	echo "./spp.sh stop                                         остановка (удаление) spp.sh (демона)"
}

function __help()
{
	echo -e "spp <ip addr> <start_port-stop_port>\t - сканирование портов и адресов"
	echo -e "spps <ip addr> <ip port> <file_res>\t  - сканирование несколькими потоками с записью в файл"
}


#функция "потока"
function _sppfp1()
{
	lurl=$_sppfp1URL
	lport=$_sppfp1port
	#
	str=$(nc -4 -w1 -vvz $_startURL $_cntport 2>&1)
	res=$(echo "$str" | grep "succeeded!")
	if [ "$res" == "" ]; then
	 res=$(echo "$str" | grep "open")
	fi
	if [ "$res" != "" ]; then
	 echo "$_sppfp1URL $_sppfp1port $str" >> "$_file_res"
	fi
}

function _sppfp()
{
	(( pcnt = 0 ))
	echo "" > "$_file_res"
	echo "work" > "$_file_stat"
	#адреса
	str=$(echo -e $_url | sed "s/\./ /g")
	echo "str=$str"
	ip1=$(echo -e $str | awk '{print($1)}')
	ip2=$(echo -e $str | awk '{print($2)}')
	ip3=$(echo -e $str | awk '{print($3)}')
	ip4=$(echo -e $str | awk '{print($4)}')
	#
	ip1=$(echo -e $ip1 | sed "s/-/ /g")
	ip2=$(echo -e $ip2 | sed "s/-/ /g")
	ip3=$(echo -e $ip3 | sed "s/-/ /g")
	ip4=$(echo -e $ip4 | sed "s/-/ /g")
	#
	ip1_1=$(echo -e $ip1 | awk '{print($1)}')
	ip1_2=$(echo -e $ip1 | awk '{print($2)}')
	if [ "$ip1_2" == "" ]; then
	ip1_2=$ip1_1
	fi
	ip2_1=$(echo -e $ip2 | awk '{print($1)}')
	ip2_2=$(echo -e $ip2 | awk '{print($2)}')
	if [ "$ip2_2" == "" ]; then
	ip2_2=$ip2_1
	fi
	ip3_1=$(echo -e $ip3 | awk '{print($1)}')
	ip3_2=$(echo -e $ip3 | awk '{print($2)}')
	if [ "$ip3_2" == "" ]; then
	ip3_2=$ip3_1
	fi
	ip4_1=$(echo -e $ip4 | awk '{print($1)}')
	ip4_2=$(echo -e $ip4 | awk '{print($2)}')
	if [ "$ip4_2" == "" ]; then
	ip4_2=$ip4_1
	fi
	_startURL="$ip1_1.$ip2_1.$ip3_1.$ip4_1"
	_stopURL="$ip1_2.$ip2_2.$ip3_2.$ip4_2"
	#echo "Start URL:$_startURL Stop URL:$_stopURL"
	#порты
	str=$(echo -e $_port | sed "s/-/ /g")
	_startport=$(echo "$str" | awk '{print($1)}')
	_stopport=$(echo "$str" | awk '{print($2)}')
	if [ "$_stopport" == "" ]; then
	 _stopport=$_startport
	fi
	#
	while( ((ip1_1 <= ip1_2)) ); do
	 if( ((ip2_1 > ip2_2)) ); then
	  ((ip2_1 = 1))
	 fi
	 while( ((ip2_1 <= ip2_2)) ); do
	  if( ((ip3_1 > ip3_2)) ); then
	   ((ip3_1 = 1))
	  fi
	  while( ((ip3_1 <= ip3_2)) ); do
	   if( ((ip4_1 > ip4_2)) ); then
	    ((ip4_1 = 1))
	   fi
	   while( ((ip4_1 <= ip4_2)) ); do
	    ((_cntport=_startport))
	    _startURL="$ip1_1.$ip2_1.$ip3_1.$ip4_1"
	    while ( ((_cntport <= _stopport)) ); do
	     mem=$(free | awk '/Mem:/ {print($4)}')
	     if ( (( mem > _memmin )) ); then
	      _sppfp1URL=$_startURL
	      _sppfp1port=$_cntport
	      _sppfp1 &
	      #usleep 1000
	      ((_cntport += 1))
	     else
	      sleep 3
	     fi
	    done
	    ((ip4_1 += 1))
           done
           ((ip3_1 += 1))
          done
	  ((ip2_1 += 1))
	 done
	 ((ip1_1 += 1))
	done
	echo "end" > "$_file_stat"
	echo "end"
}


function _sppf()
{
	echo "" > "$_file_res"
	echo "work" > "$_file_stat"
	#адреса
	str=$(echo -e $_url | sed "s/\./ /g")
	echo "str=$str"
	ip1=$(echo -e $str | awk '{print($1)}')
	ip2=$(echo -e $str | awk '{print($2)}')
	ip3=$(echo -e $str | awk '{print($3)}')
	ip4=$(echo -e $str | awk '{print($4)}')
	#
	ip1=$(echo -e $ip1 | sed "s/-/ /g")
	ip2=$(echo -e $ip2 | sed "s/-/ /g")
	ip3=$(echo -e $ip3 | sed "s/-/ /g")
	ip4=$(echo -e $ip4 | sed "s/-/ /g")
	#
	ip1_1=$(echo -e $ip1 | awk '{print($1)}')
	ip1_2=$(echo -e $ip1 | awk '{print($2)}')
	if [ "$ip1_2" == "" ]; then
	ip1_2=$ip1_1
	fi
	ip2_1=$(echo -e $ip2 | awk '{print($1)}')
	ip2_2=$(echo -e $ip2 | awk '{print($2)}')
	if [ "$ip2_2" == "" ]; then
	ip2_2=$ip2_1
	fi
	ip3_1=$(echo -e $ip3 | awk '{print($1)}')
	ip3_2=$(echo -e $ip3 | awk '{print($2)}')
	if [ "$ip3_2" == "" ]; then
	ip3_2=$ip3_1
	fi
	ip4_1=$(echo -e $ip4 | awk '{print($1)}')
	ip4_2=$(echo -e $ip4 | awk '{print($2)}')
	if [ "$ip4_2" == "" ]; then
	ip4_2=$ip4_1
	fi
	_startURL="$ip1_1.$ip2_1.$ip3_1.$ip4_1"
	_stopURL="$ip1_2.$ip2_2.$ip3_2.$ip4_2"
	echo "Start URL:$_startURL Stop URL:$_stopURL"
	#порты
	str=$(echo -e $_port | sed "s/-/ /g")
	_startport=$(echo "$str" | awk '{print($1)}')
	_stopport=$(echo "$str" | awk '{print($2)}')
	if [ "$_stopport" == "" ]; then
	 _stopport=$_startport
	fi
	#
	while( ((ip1_1 <= ip1_2)) ); do
	 if( ((ip2_1 > ip2_2)) ); then
	  ((ip2_1 = 1))
	 fi
	 while( ((ip2_1 <= ip2_2)) ); do
	  if( ((ip3_1 > ip3_2)) ); then
	   ((ip3_1 = 1))
	  fi
	  while( ((ip3_1 <= ip3_2)) ); do
	   if( ((ip4_1 > ip4_2)) ); then
	    ((ip4_1 = 1))
	   fi
	   while( ((ip4_1 <= ip4_2)) ); do
	    ((_cntport=_startport))
	    _startURL="$ip1_1.$ip2_1.$ip3_1.$ip4_1"
	    while ( ((_cntport <= _stopport)) ); do
	     str=$(nc -4 -w1 -vvz $_startURL $_cntport 2>&1)
	     res=$(echo "$str" | grep "succeeded!")
	     if [ "$res" == "" ]; then
	      res=$(echo "$str" | grep "open")
	     fi
	     if [ "$res" != "" ]; then
	      echo "$_startURL $_cntport" >> "$_file_res"
	     fi
	     res=$(echo "$str" | grep "No route to host")
	     if [ "$res" != "" ]; then
	      break
	     fi
	     ((_cntport += 1))
	    done
	    ((ip4_1 += 1))
           done
           ((ip3_1 += 1))
          done
	  ((ip2_1 += 1))
	 done
	 ((ip1_1 += 1))
	done
	echo "end" > "$_file_stat"
	echo "end"
}

function _spp()
{
	
	#адреса
	str=$(echo -e $_url | sed "s/\./ /g")
	echo "str=$str"
	ip1=$(echo -e $str | awk '{print($1)}')
	ip2=$(echo -e $str | awk '{print($2)}')
	ip3=$(echo -e $str | awk '{print($3)}')
	ip4=$(echo -e $str | awk '{print($4)}')
	#
	ip1=$(echo -e $ip1 | sed "s/-/ /g")
	ip2=$(echo -e $ip2 | sed "s/-/ /g")
	ip3=$(echo -e $ip3 | sed "s/-/ /g")
	ip4=$(echo -e $ip4 | sed "s/-/ /g")
	#
	ip1_1=$(echo -e $ip1 | awk '{print($1)}')
	ip1_2=$(echo -e $ip1 | awk '{print($2)}')
	if [ "$ip1_2" == "" ]; then
	ip1_2=$ip1_1
	fi
	ip2_1=$(echo -e $ip2 | awk '{print($1)}')
	ip2_2=$(echo -e $ip2 | awk '{print($2)}')
	if [ "$ip2_2" == "" ]; then
	ip2_2=$ip2_1
	fi
	ip3_1=$(echo -e $ip3 | awk '{print($1)}')
	ip3_2=$(echo -e $ip3 | awk '{print($2)}')
	if [ "$ip3_2" == "" ]; then
	ip3_2=$ip3_1
	fi
	ip4_1=$(echo -e $ip4 | awk '{print($1)}')
	ip4_2=$(echo -e $ip4 | awk '{print($2)}')
	if [ "$ip4_2" == "" ]; then
	ip4_2=$ip4_1
	fi
	_startURL="$ip1_1.$ip2_1.$ip3_1.$ip4_1"
	_stopURL="$ip1_2.$ip2_2.$ip3_2.$ip4_2"
	echo "Start URL:$_startURL Stop URL:$_stopURL"
	#порты
	str=$(echo -e $_port | sed "s/-/ /g")
	_startport=$(echo "$str" | awk '{print($1)}')
	_stopport=$(echo "$str" | awk '{print($2)}')
	if [ "$_stopport" == "" ]; then
	 _stopport=$_startport
	fi
	#
	while( ((ip1_1 <= ip1_2)) ); do
	 if( ((ip2_1 > ip2_2)) ); then
	  ((ip2_1 = 1))
	 fi
	 while( ((ip2_1 <= ip2_2)) ); do
	  if( ((ip3_1 > ip3_2)) ); then
	   ((ip3_1 = 1))
	  fi
	  while( ((ip3_1 <= ip3_2)) ); do
	   if( ((ip4_1 > ip4_2)) ); then
	    ((ip4_1 = 1))
	   fi
	   while( ((ip4_1 <= ip4_2)) ); do
	    ((_cntport=_startport))
	    _startURL="$ip1_1.$ip2_1.$ip3_1.$ip4_1"
	    while ( ((_cntport <= _stopport)) ); do
	     str=$(nc -4 -w1 -vvz $_startURL $_cntport 2>&1)
	     res=$(echo "$str" | grep "succeeded!")
	     if [ "$res" == "" ]; then
	      res=$(echo "$str" | grep "open")
	     fi
	     if [ "$res" != "" ]; then
	      echo "$_startURL $_cntport"
	     fi
	     res=$(echo "$str" | grep "No route to host")
	     if [ "$res" != "" ]; then
	      break
	     fi
	     ((_cntport += 1))
	    done
	    ((ip4_1 += 1))
           done
           ((ip3_1 += 1))
          done
	  ((ip2_1 += 1))
	 done
	 ((ip1_1 += 1))
	done
	echo "end"
}

function _stop_spp()
{
	sleep 5
	killall -s 9 spp.sh &
}

case $1 in
	"help")
		_help
	;;
	"--help")
		__help
	;;
	"version")
		echo -e "******\tspp.sh Date:$vdate Version:$vversion\t******"
	;;
	"stop")
		if [ "$_file_stat" == "" ]; then
			_file_stat=$_file_stat_def
		fi
		echo "end" > "$_file_stat"
		_stop_spp &
		exit 0
	;;
	"-ip")
		_url=$2
		case $3 in
			"-p")
				_port=$4
				if [ "$_port" == "" ]
				 then
				  echo "-p parametr ?"
				else
				  case $5 in
					"-f")
						_file_res=$6
						if [ "$_file_res" == "" ]; then
							_file_res=$_file_res_def
						fi
						if [ "$_file_stat" == "" ]; then
							_file_stat=$_file_stat_def
						fi
						_sppf
					;;
					"-fp")
						_file_res=$6
						if [ "$_file_res" == "" ]; then
							_file_res=$_file_res_def
						fi
						if [ "$_file_stat" == "" ]; then
							_file_stat=$_file_stat_def
						fi
						_sppfp
					;;
					"-fpd")
						_file_res=$6
						if [ "$_file_res" == "" ]; then
							_file_res=$_file_res_def
						fi
						if [ "$_file_stat" == "" ]; then
							_file_stat=$_file_stat_def
						fi
						_sppfp &
						echo "started!"
					;;
					*)
						_spp
					;;
				  esac
				fi
			;;
			*)
				echo "parametr ???"
			;;
		esac
	;;
	"-p")
		_port=$2
		case $3 in
			"-ip")
				_url=$4
				if [ "$_url" == "" ]
				 then
				  echo "-ip parametr ?"
				else
				 case $5 in
					"-f")
						_file_res=$6
						if [ "$_file_res" == "" ]; then
							_file_res=$_file_res_def
						fi
						if [ "$_file_stat" == "" ]; then
							_file_stat=$_file_stat_def
						fi
						_sppf
					;;
					"-fp")
						_file_res=$6
						if [ "$_file_res" == "" ]; then
							_file_res=$_file_res_def
						fi
						if [ "$_file_stat" == "" ]; then
							_file_stat=$_file_stat_def
						fi
						_sppfp
					;;
					"-fpd")
						_file_res=$6
						if [ "$_file_res" == "" ]; then
							_file_res=$_file_res_def
						fi
						if [ "$_file_stat" == "" ]; then
							_file_stat=$_file_stat_def
						fi
						_sppfp &
						echo "started!"
					;;
					*)
						_spp
					;;
				  esac
				fi
			;;
			*)
				echo "parametr ???"
			;;
		esac
	;;
	*)
		echo "use \"help\""
	;;
esac

